/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Contents of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.130 - (show annotations) (download)
Thu Mar 22 19:16:22 2012 UTC (2 years, 4 months ago) by vapier
Branch: MAIN
Changes since 1.129: +9 -25 lines
drop AT_NOE{ACLOCAL,AUTOCONF,AUTOHEADER} as people should not be disabling these things, and document AT_NOEAUTOMAKE as a hack rather than a normally acceptable solution

1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.129 2012/03/22 15:14:53 vapier Exp $
4
5 # @ECLASS: autotools.eclass
6 # @MAINTAINER:
7 # base-system@gentoo.org
8 # @BLURB: Regenerates auto* build scripts
9 # @DESCRIPTION:
10 # This eclass is for safely handling autotooled software packages that need to
11 # regenerate their build scripts. All functions will abort in case of errors.
12
13 # Note: We require GNU m4, as does autoconf. So feel free to use any features
14 # from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16 if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17 ___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
18
19 inherit eutils libtool
20
21 # @ECLASS-VARIABLE: WANT_AUTOCONF
22 # @DESCRIPTION:
23 # The major version of autoconf your package needs
24 : ${WANT_AUTOCONF:=latest}
25
26 # @ECLASS-VARIABLE: WANT_AUTOMAKE
27 # @DESCRIPTION:
28 # The major version of automake your package needs
29 : ${WANT_AUTOMAKE:=latest}
30
31 # @ECLASS-VARIABLE: WANT_LIBTOOL
32 # @DESCRIPTION:
33 # Do you want libtool? Valid values here are "latest" and "none".
34 : ${WANT_LIBTOOL:=latest}
35
36 # @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37 # @INTERNAL
38 # @DESCRIPTION:
39 # CONSTANT!
40 # The latest major version/slot of automake available on each arch. #312315
41 # If a newer slot is stable on any arch, and is NOT reflected in this list,
42 # then circular dependencies may arise during emerge @system bootstraps.
43 # Do NOT change this variable in your ebuilds!
44 # If you want to force a newer minor version, you can specify the correct
45 # WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
46 _LATEST_AUTOMAKE=( 1.11.1:1.11 )
47
48 _automake_atom="sys-devel/automake"
49 _autoconf_atom="sys-devel/autoconf"
50 if [[ -n ${WANT_AUTOMAKE} ]]; then
51 case ${WANT_AUTOMAKE} in
52 none) _automake_atom="" ;; # some packages don't require automake at all
53 # if you change the "latest" version here, change also autotools_run_tool
54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
64 esac
65 export WANT_AUTOMAKE
66 fi
67
68 if [[ -n ${WANT_AUTOCONF} ]] ; then
69 case ${WANT_AUTOCONF} in
70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
72 # if you change the "latest" version here, change also autotools_env_setup
73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
75 esac
76 export WANT_AUTOCONF
77 fi
78
79 _libtool_atom="sys-devel/libtool"
80 if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87 fi
88
89 AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
90 RDEPEND=""
91
92 # @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
93 # @DESCRIPTION:
94 # Set to 'no' to disable automatically adding to DEPEND. This lets
95 # ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
96 # their own DEPEND string.
97 : ${AUTOTOOLS_AUTO_DEPEND:=yes}
98 if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
99 DEPEND=${AUTOTOOLS_DEPEND}
100 fi
101
102 unset _automake_atom _autoconf_atom
103
104 # @ECLASS-VARIABLE: AM_OPTS
105 # @DEFAULT_UNSET
106 # @DESCRIPTION:
107 # Additional options to pass to automake during
108 # eautoreconf call.
109
110 # @ECLASS-VARIABLE: AT_NOEAUTOMAKE
111 # @DEFAULT_UNSET
112 # @DESCRIPTION:
113 # Don't run eautomake command if set to 'yes'; only used to workaround
114 # broken packages. Generally you should, instead, fix the package to
115 # not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
116
117 # @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
118 # @DEFAULT_UNSET
119 # @DESCRIPTION:
120 # Don't run elibtoolize command if set to 'yes',
121 # useful when elibtoolize needs to be ran with
122 # particular options
123
124 # @ECLASS-VARIABLE: AT_M4DIR
125 # @DESCRIPTION:
126 # Additional director(y|ies) aclocal should search
127 : ${AT_M4DIR:=}
128
129 # @ECLASS-VARIABLE: AT_SYS_M4DIR
130 # @INTERNAL
131 # @DESCRIPTION:
132 # For system integrators, a list of additional aclocal search paths.
133 # This variable gets eval-ed, so you can use variables in the definition
134 # that may not be valid until eautoreconf & friends are run.
135 : ${AT_SYS_M4DIR:=}
136
137 # @FUNCTION: eautoreconf
138 # @DESCRIPTION:
139 # This function mimes the behavior of autoreconf, but uses the different
140 # eauto* functions to run the tools. It doesn't accept parameters, but
141 # the directory with include files can be specified with AT_M4DIR variable.
142 #
143 # Should do a full autoreconf - normally what most people will be interested in.
144 # Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
145 eautoreconf() {
146 local x auxdir g
147
148 if [[ -z ${AT_NO_RECURSIVE} ]]; then
149 # Take care of subdirs
150 for x in $(autotools_get_subdirs); do
151 if [[ -d ${x} ]] ; then
152 pushd "${x}" >/dev/null
153 AT_NOELIBTOOLIZE="yes" eautoreconf
154 popd >/dev/null
155 fi
156 done
157 fi
158
159 auxdir=$(autotools_get_auxdir)
160
161 einfo "Running eautoreconf in '${PWD}' ..."
162 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
163 eaclocal
164 [[ ${CHOST} == *-darwin* ]] && g=g
165 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
166 _elibtoolize --copy --force --install
167 else
168 _elibtoolize --copy --force
169 fi
170 eautoconf
171 eautoheader
172 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
173
174 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
175
176 # Call it here to prevent failures due to elibtoolize called _before_
177 # eautoreconf. We set $S because elibtoolize runs on that #265319
178 S=${PWD} elibtoolize --force
179
180 return 0
181 }
182
183 # @FUNCTION: eaclocal_amflags
184 # @DESCRIPTION:
185 # Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
186 # (most) of the crazy crap that people throw at us.
187 eaclocal_amflags() {
188 local aclocal_opts amflags_file
189
190 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
191 [[ -e ${amflags_file} ]] || continue
192 # setup the env in case the pkg does something crazy
193 # in their ACLOCAL_AMFLAGS. like run a shell script
194 # which turns around and runs autotools. #365401
195 # or split across multiple lines. #383525
196 autotools_env_setup
197 aclocal_opts=$(sed -n \
198 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
199 # match the first line
200 s:[^=]*=::p; \
201 # then gobble up all escaped lines
202 : nextline /\\\\$/{ n; p; b nextline; } \
203 }" ${amflags_file})
204 eval aclocal_opts=\""${aclocal_opts}"\"
205 break
206 done
207
208 echo ${aclocal_opts}
209 }
210
211 # @FUNCTION: eaclocal
212 # @DESCRIPTION:
213 # These functions runs the autotools using autotools_run_tool with the
214 # specified parametes. The name of the tool run is the same of the function
215 # without e prefix.
216 # They also force installing the support files for safety.
217 # Respects AT_M4DIR for additional directories to search for macro's.
218 eaclocal() {
219 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
220 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
221 }
222
223 # @FUNCTION: _elibtoolize
224 # @DESCRIPTION:
225 # Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
226 # libtool.eclass.
227 _elibtoolize() {
228 local opts g=
229
230 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
231 # check for both it and the current AC_PROG_LIBTOOL)
232 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
233
234 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
235
236 [[ ${CHOST} == *-darwin* ]] && g=g
237 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
238
239 # Need to rerun aclocal
240 eaclocal
241 }
242
243 # @FUNCTION: eautoheader
244 # @DESCRIPTION:
245 # Runs autoheader.
246 eautoheader() {
247 # Check if we should run autoheader
248 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
249 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
250 }
251
252 # @FUNCTION: eautoconf
253 # @DESCRIPTION:
254 # Runs autoconf.
255 eautoconf() {
256 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
257 echo
258 eerror "No configure.{ac,in} present in '${PWD}'!"
259 echo
260 die "No configure.{ac,in} present!"
261 fi
262
263 autotools_run_tool --at-m4flags autoconf "$@"
264 }
265
266 # @FUNCTION: eautomake
267 # @DESCRIPTION:
268 # Runs automake.
269 eautomake() {
270 local extra_opts
271 local makefile_name
272
273 # Run automake if:
274 # - a Makefile.am type file exists
275 # - the configure script is using the AM_INIT_AUTOMAKE directive
276 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
277 [[ -f ${makefile_name} ]] && break
278 done
279
280 if [[ -z ${makefile_name} ]] ; then
281 # Really we should just use autotools_check_macro ...
282 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
283 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
284 return 0
285 fi
286
287 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
288 local used_automake
289 local installed_automake
290
291 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
292 sed -e 's:.*(GNU automake) ::')
293 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
294 sed -e 's:.*by automake \(.*\) from .*:\1:')
295
296 if [[ ${installed_automake} != ${used_automake} ]]; then
297 einfo "Automake used for the package (${used_automake}) differs from"
298 einfo "the installed version (${installed_automake})."
299 eautoreconf
300 return 0
301 fi
302 fi
303
304 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
305 || extra_opts="${extra_opts} --foreign"
306
307 # --force-missing seems not to be recognized by some flavours of automake
308 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
309 }
310
311 # @FUNCTION: eautopoint
312 # @DESCRIPTION:
313 # Runs autopoint (from the gettext package).
314 eautopoint() {
315 autotools_run_tool autopoint "$@"
316 }
317
318 # @FUNCTION: config_rpath_update
319 # @USAGE: [destination]
320 # @DESCRIPTION:
321 # Some packages utilize the config.rpath helper script, but don't
322 # use gettext directly. So we have to copy it in manually since
323 # we can't let `autopoint` do it for us.
324 config_rpath_update() {
325 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
326
327 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
328 [[ $# -eq 0 ]] && return 0
329
330 einfo "Updating all config.rpath files"
331 for dst in "$@" ; do
332 einfo " ${dst}"
333 cp "${src}" "${dst}" || die
334 done
335 }
336
337 # Internal function to run an autotools' tool
338 autotools_env_setup() {
339 # We do the "latest" → version switch here because it solves
340 # possible order problems, see bug #270010 as an example.
341 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
342 local pv
343 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
344 # has_version respects ROOT, but in this case, we don't want it to,
345 # thus "ROOT=/" prefix:
346 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
347 done
348 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
349 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
350 fi
351 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
352 }
353 autotools_run_tool() {
354 # Process our own internal flags first
355 local autofail=true m4flags=false
356 while [[ -n $1 ]] ; do
357 case $1 in
358 --at-no-fail) autofail=false;;
359 --at-m4flags) m4flags=true;;
360 # whatever is left goes to the actual tool
361 *) break;;
362 esac
363 shift
364 done
365
366 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
367 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
368 fi
369
370 autotools_env_setup
371
372 local STDERR_TARGET="${T}/$1.out"
373 # most of the time, there will only be one run, but if there are
374 # more, make sure we get unique log filenames
375 if [[ -e ${STDERR_TARGET} ]] ; then
376 local i=1
377 while :; do
378 STDERR_TARGET="${T}/$1-${i}.out"
379 [[ -e ${STDERR_TARGET} ]] || break
380 : $(( i++ ))
381 done
382 fi
383
384 if ${m4flags} ; then
385 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
386 fi
387
388 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
389
390 ebegin "Running $@"
391 "$@" >> "${STDERR_TARGET}" 2>&1
392 if ! eend $? && ${autofail} ; then
393 echo
394 eerror "Failed Running $1 !"
395 eerror
396 eerror "Include in your bugreport the contents of:"
397 eerror
398 eerror " ${STDERR_TARGET}"
399 echo
400 die "Failed Running $1 !"
401 fi
402 }
403
404 # Internal function to check for support
405 autotools_check_macro() {
406 [[ -f configure.ac || -f configure.in ]] || return 0
407 local macro
408 for macro ; do
409 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
410 done
411 return 0
412 }
413
414 # Internal function to look for a macro and extract its value
415 autotools_check_macro_val() {
416 local macro=$1 scan_out
417
418 autotools_check_macro "${macro}" | \
419 gawk -v macro="${macro}" \
420 '($0 !~ /^[[:space:]]*(#|dnl)/) {
421 if (match($0, macro ":(.*)$", res))
422 print res[1]
423 }' | uniq
424
425 return 0
426 }
427
428 # Internal function to get additional subdirs to configure
429 autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
430 autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
431
432 _autotools_m4dir_include() {
433 local x include_opts
434
435 for x in "$@" ; do
436 case ${x} in
437 # We handle it below
438 -I) ;;
439 *)
440 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
441 include_opts+=" -I ${x}"
442 ;;
443 esac
444 done
445
446 echo ${include_opts}
447 }
448 autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
449 autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
450
451 fi

  ViewVC Help
Powered by ViewVC 1.1.20